#
# This file is part of Invenio.
# Copyright (C) 2016-2018 CERN.
#
# Invenio is free software; you can redistribute it and/or modify it
# under the terms of the MIT License; see LICENSE file for more details.

"""Initial version of tables."""

import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = '91f1ed75d56f'
down_revision = '35c1075e6360'
branch_labels = ()
depends_on = None


def upgrade():
    """Upgrade database."""
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('taxonomy_term',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('slug', sa.String(length=64), nullable=True),
    sa.Column('extra_data', sa.JSON(), nullable=True),
    sa.Column('tree_id', sa.Integer(), nullable=True),
    sa.Column('parent_id', sa.Integer(), nullable=True),
    sa.Column('lft', sa.Integer(), nullable=False),
    sa.Column('rgt', sa.Integer(), nullable=False),
    sa.Column('level', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['parent_id'], ['taxonomy_term.id'], name=op.f('fk_taxonomy_term_parent_id_taxonomy_term'), ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id', name=op.f('pk_taxonomy_term')),
    sa.UniqueConstraint('slug', 'parent_id', name=op.f('uq_taxonomy_term_slug_parent')),
    sa.UniqueConstraint('slug', 'tree_id', name=op.f('uq_taxonomy_term_slug_tree'))
    )
    op.create_index(op.f('ix_taxonomy_term_slug'), 'taxonomy_term', ['slug'], unique=False)
    # ### end Alembic commands ###


def downgrade():
    """Downgrade database."""
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_taxonomy_term_slug'), table_name='taxonomy_term')
    op.drop_table('taxonomy_term')
    # ### end Alembic commands ###
